/*
 *  Copyright (c) Members of the EGEE Collaboration. 2004. 
 *  See http://www.eu-egee.org/partners/ for details on the copyright
 *  holders.  
 *
 *  Licensed under the Apache License, Version 2.0 (the "License"); 
 *  you may not use this file except in compliance with the License. 
 *  You may obtain a copy of the License at 
 *
 *      http://www.apache.org/licenses/LICENSE-2.0 
 *
 *  Unless required by applicable law or agreed to in writing, software 
 *  distributed under the License is distributed on an "AS IS" BASIS, 
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 *  See the License for the specific language governing permissions and 
 *  limitations under the License.
 *
 *  GLite Data SRM Util CPP: SrmRmDir Class
 *
 *  Authors: Paolo Badino <paolo.badino@cern.ch>
 *  Version info: $Id: SrmRmDir.h,v 1.3 2008/03/13 16:32:44 ptedesco Exp $
 *  Release: $Name: glite-data-srm-util-cpp_R_2_0_0_1 $
 *
 */
#ifndef GLITE_DATA_SRM_UTIL_CPP_SRM_RMDIR_H_
#define GLITE_DATA_SRM_UTIL_CPP_SRM_RMDIR_H_

#include "glite/data/srm/util/details/SynchRequest.h"
#include "glite/data/srm/util/details/Final.h"

namespace glite {
namespace data  {
namespace srm   {
namespace util  {

/**
 * Abstract Class for SrmRmDir synchronous requests
 */ 
class SrmRmDir : public details::SynchRequest, public details::Final<SrmRmDir>{
public: 
    // -------------------------------------------------------------------------
    // Use the factory methods
    // -------------------------------------------------------------------------
    using details::Final<SrmRmDir>::create;

    // -------------------------------------------------------------------------
    // The SrmRmDir properties
    // -------------------------------------------------------------------------

    /**
     * The Directory path
     */
    std::string   directoryPath;
    /**
     * Recursive flag
     */
    bool          recursive;

    /**
     * destructor
     */
    virtual ~SrmRmDir(){}
        
protected:

    /**
     * Constructor
     */
    explicit SrmRmDir(Context::Ptr ctx):
        details::SynchRequest(ctx),
        recursive(false){}

private:
    /**
     * Default Constructor. Not Implemented
     */
    SrmRmDir();

private:
    
};

} // End namespace util
} // End namespace srm
} // End namespace data
} // End namespace glite

#endif //GLITE_DATA_SRM_UTIL_CPP_SRM_RMDIR_H_
